# -*- encoding=utf8 -*-
from air_case.public1.public1.public1 import get_hosid
from common.fileUtls import FileUtils
from common.run_cmd_script import execute_command

__author__ = "xiaohesheng"

"""
case_tag:api,spd_core,a_a4_流程四_基础模块设置,id2302,id2302-4,sit,on
主数据平台:a_a4_流程四_基础模块设置
python runner_test.py tag id2302-4 debug mdm3

"""

from common.common_func import commonFuc
from air_case.b1_herp3_login.登录内网系统.登录内网系统 import login_system
from airtest.core.api import using
import sys
import time

module = "b5_spd3_core_business_flow"


def test1():
    # 院区新增
    execute_command("python runner_test.py tag id2263-4 debug sit")
    # 新增科室
    execute_command(
        "python runner_test.py tag id2263-19,id2263-20,id2263-21,id2263-22,id2263-23,id2263-24,id2263-25,id2263-26 debug sit")
    # 一键导入所有产品
    execute_command("python runner_test.py tag id2263-48 debug sit")
    #导入同步过来的新产品，防止因同步时间差导致新建的产品没有导入过来
    for i in range(1, 6):
        info = FileUtils().r_info8('b5_spd3_core_business_flow', "产品审核信息", 'message%s' % i)
        hosGoodsId = info['hosGoodsId']
        import_goods(hosGoodsId)

    # r_b8库房管理_库区设置_同步库房信息
    execute_command("python runner_test.py tag id2263-221 debug sit")
    # 新增用户
    execute_command("python runner_test.py tag id2263-253 debug sit")
    # 根据院区名称查询中心库房id
    execute_command("python runner_test.py tag id2263-222 debug sit")
    # 新增库区
    execute_command("python runner_test.py tag id2263-226 debug sit")
    # 查询库区
    execute_command("python runner_test.py tag id2263-228 debug sit")
    # r_d0库房管理_库区设置_人员管理_添加人员_查询人员
    execute_command("python runner_test.py tag id2263-233 debug sit")
    # r_d2库房管理_库区设置_人员管理_添加人员
    execute_command("python runner_test.py tag id2263-235 debug sit")
    # r_d4库房管理_库区设置_货位管理_添加货位
    execute_command("python runner_test.py tag id2263-237 debug sit")
    # 科室管理-科室人员查询 设置科室负责人
    execute_command("python runner_test.py tag id2263-219 debug sit")

def  import_goods(hosGoodsId):
    module = "b2_herp3_bs"
    # 内网登录
    username = commonFuc().get_business_data(module, "username")
    # print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token, projectCode, uxid, corpId, info = login_system(username, password).get_token()
    # 院区产品设置_查询院区产品
    url = commonFuc().get_api_add_port_url() + commonFuc().get_business_data(module, "mcmsDeptGoodsInfo_url")
    print('院区产品设置_查询院区产品',url)
    # 获取请求头信息
    headers = commonFuc().get_business_data(module, "json_headers2",
                                            commonFuc().get_business_data(module, "json_contentType"), token,
                                            commonFuc().get_business_data(module, "X-APP-CODE"))
    # 获取院区id
    branch_id = FileUtils().r_info(module, '院区新增')["branch_id"]
    # hosGoodsId = FileUtils().r_info8('b5_spd3_core_business_flow', '产品审核信息', 'message2')["hosGoodsId"]
    goodsId=hosGoodsId.replace(get_hosid(), "")
    # #请求体
    request_body = commonFuc().get_business_data(module, "payload32_1",get_hosid(), goodsId,branch_id)
    print(request_body)
    # # # 发送请求
    while True:
        result = commonFuc().http_post(url, request_body, headers)
        total=commonFuc().analysis_json('total',commonFuc().analysis_json('data',result))
        if total==0:
            print('产品暂时没有同步到内网,等待6秒')
            time.sleep(6)
            # 再次调用一键导入产品
            execute_command("python runner_test.py tag id2263-48 debug sit")
        else:
            break
    print('result', result)


def test2():  # 科室添加产品信息(产品是从外网同步过来的)
    module = "b2_herp3_bs"
    # 内网登录
    username = commonFuc().get_business_data(module, "username")
    # print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token, projectCode, uxid, corpId, info = login_system(username, password).get_token()

    #
    url = commonFuc().get_api_add_port_url()+commonFuc().get_business_data(module, "basic_mcmsGoodsInfo_insert")
    print('basic_mcmsGoodsInfo_insert',url)
    # 获取请求头信息
    headers = commonFuc().get_business_data(module, "json_headers2",
                                            commonFuc().get_business_data(module, "json_contentType"), token,
                                            commonFuc().get_business_data(module, "X-APP-CODE"))
    list2 = []
    i = 1
    while True:
        if i == 1000:
            print('6000秒过去了，产品还没过来，检查同步是否正常')
            break
        try:
            for i in range(1, 6):
                info = FileUtils().r_info8('b5_spd3_core_business_flow', "产品审核信息", 'message%s' % i)
                hosGoodsId = info['hosGoodsId']
                list2.append(hosGoodsId)
        except:
            print('产品没有同步过来，等待6秒')
            time.sleep(6)
            i = i + 1
            continue
        else:
            break

    dept2_id = FileUtils().r_info(module, '科室信息')["dept2_id"]
    j=1
    for i in list2:
        # 请求体
        if j==1:
            request_body = commonFuc().get_business_data(module, "payload58_6_3", dept2_id, i,20)
        elif j==2:
            request_body = commonFuc().get_business_data(module, "payload58_6_3", dept2_id, i, 10)
        elif j==3:
            request_body = commonFuc().get_business_data(module, "payload58_6_3", dept2_id, i, 60)
        else:
            request_body = commonFuc().get_business_data(module, "payload58_6_3", dept2_id, i,20)
        j=j+1
        request_body = '[' + str(request_body) + ']'
        new_request_body = request_body.replace("'", '"')
        print(new_request_body)
        import json
        request_body_json = json.loads(new_request_body)
        # # # 发送请求
        result = commonFuc().http_post(url, request_body_json, headers)
        print('resultaaaaaaaaaaaaaaaaaaaaaaaaaaa', result)
        # 断言
        # checkDict=commonFuc().get_business_data(module,'checkDict10')
        # commonFuc().check_result(checkDict,result)
        code = commonFuc().analysis_json('code', result)
        data = commonFuc().analysis_json('data', result)
        if code == 0 and data == 1:
            commonFuc().check_text_exist(0, result)
        else:
            commonFuc().check_text_exist('error', result)



def dept_query_all():  # 科室查询，将科室id写入文件中
    module = "b2_herp3_bs"
    # 内网登录
    username = commonFuc().get_business_data(module, "username")
    # print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token, projectCode, uxid, corpId, info = login_system(username, password).get_token()
    # print( token,projectCode,uxid,corpId,info)
    # b9_科室管理_科室登记_科室查询
    branch_id = FileUtils().r_info(module, '院区新增')["branch_id"]
    url = commonFuc().get_api_add_port_url() + commonFuc().get_business_data(module, "deptPage_url")

    # 获取请求头信息
    headers = commonFuc().get_business_data(module, "json_headers2",
                                            commonFuc().get_business_data(module, "json_contentType"), token,
                                            commonFuc().get_business_data(module, "X-APP-CODE"))
    # #请求体
    request_body = commonFuc().get_business_data(module, "payload13", branch_id)
    print(request_body)
    # # # 发送请求
    result = commonFuc().http_post(url, request_body, headers)
    print('result', result)
    data = commonFuc().analysis_json('data', result)
    total = commonFuc().analysis_json('total', data)
    if total == 4:
        commonFuc().check_text_exist(0, result)
    else:
        commonFuc().check_text_exist('error', result)
    # 将deptid写入文件
    data1 = commonFuc().analysis_json('data', data)
    print('data1', data1)
    info = []
    for i in data1:
        deptid = commonFuc().analysis_json('id', i)
        info.append(deptid)
    titlename = ['deptid1', 'deptid2', 'deptid3', 'deptid4']
    FileUtils().w_info8(info, module, '所有科室id', titlename, 'message6')


def grants_user(orgName='d69a68df361a4289b2262e4ef75b55a5', mgrRangeId='feb0cc16618c437fb4d033cd339a0377'):
    module = "b2_herp3_bs"
    # 登录获取用户id等信息，使用创建的用户登录===========开始
    info = FileUtils().r_info8(module, "用户名信息", 'message3')
    print(info)
    username1 = info['username1']

    username = username1
    ## print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token1, projectCode1, uxid1, corpId1, info1 = login_system(username, password).get_token()
    # 登录获取用户id等信息，使用创建的用户登录============结束
    # 内网登录
    username = commonFuc().get_business_data(module, "username")
    ## print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token, projectCode, uxid, corpId, info = login_system(username, password).get_token()
    # print( token,projectCode,uxid,corpId,info)

    url = commonFuc().get_api_add_port_url() + commonFuc().get_business_data(module, "sys_user_grants_url")
    # 获取请求头信息
    headers = commonFuc().get_business_data(module, "json_headers2",
                                            commonFuc().get_business_data(module, "json_contentType"), token,
                                            commonFuc().get_business_data(module, "X-APP-CODE"))
    userId = uxid1
    mgrBranchId = FileUtils().r_info(module, '院区新增')["branch_id"]
    mgrBranchName = FileUtils().r_info(module, '院区新增')["branch_name"]
    deptid1 = FileUtils().r_info8(module, '所有科室id','message6')["deptid1"]
    deptid2 = FileUtils().r_info8(module, '所有科室id','message6')["deptid2"]
    deptid3 = FileUtils().r_info8(module, '所有科室id','message6')["deptid3"]
    deptid4 = FileUtils().r_info8(module, '所有科室id','message6')["deptid4"]

    # # 请求体
    request_body = commonFuc().get_business_data(module, "payload63_12_2", userId, mgrBranchId, mgrBranchName, deptid1,
                                                 mgrBranchId, mgrBranchName, deptid2, mgrBranchId, mgrBranchName,
                                                 deptid3, mgrBranchId, mgrBranchName, deptid4
                                                 )
    print('request_body', request_body)
    # # # # 发送请求
    result = commonFuc().http_post(url, request_body, headers)
    print('resultaaaaaaaaaaaaaaaaaaa', result)
    # 断言
    code = commonFuc().analysis_json('code', result)
    data = commonFuc().analysis_json('data', result)
    if code == 0 and data == 4:
        commonFuc().check_text_exist(0, result)
    else:
        commonFuc().check_text_exist('error', result)

try:
    test1()
    test2()# 科室添加产品信息(产品是从外网同步过来的)
    dept_query_all()# 科室查询，将科室id写入文件中
    grants_user()#给用户授权
    commonFuc().check_text_exist_result_text('succees', 'succees')
except Exception as e:
    commonFuc().check_text_exist_result_text('succees','error')
    print("发生异常：", str(e))