# -*- encoding=utf8 -*-
import sys

from airtest.core.helper import using

from common.db.sql.sql_del_branch_info import delData
from common.db.sql.sql_del_kind_goodsinfo import delKindGoodsinfo
from common.db.sql.sql_del_notices_info import delByNoticeName
from common.fileUtls import FileUtils
from common.timeUtils import timeUtils

__author__ = "xiaohesheng"

"""
case_tag:api,herp-web,r_c3库房管理_库区设置_新增库区,id2263,id2263-226,sit,on
内网:r_c3库房管理_库区设置_新增库区
"""

from common.common_func import commonFuc
from air_case.b1_herp3_login.登录内网系统.登录内网系统 import login_system

module = "b2_herp3_bs"


def test2(stockId='c66b6ed38dbb4fbc8603dc00cdabb572'):
    """
     场景:r_c3库房管理_库区设置_新增库区
     用例名称：r_c3库房管理_库区设置_新增库区
     输入：""
     输出："rtn_msg": {"code": 0, "msg": null,    "data":[]}
    """
    # 内网登录
    username = commonFuc().get_business_data(module, "username")
    ## print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token, projectCode, uxid, corpId, info = login_system(username, password).get_token()
    # print( token,projectCode,uxid,corpId,info)

    # r_c3库房管理_库区设置_新增库区
    # 新增前删除货位,库区,再次新增库区时不会因重复数据而无法新增
    delData().Delete_probeInfo()
    # pro_path = commonFuc().get_pro_path()
    # sys.path.append(pro_path + r'\\air_case\\b2_herp3_bs\\r_b5科室管理_科室人员查询_按科室查询人员_获取用户id.air')
    # using(pro_path + r'\\air_case\\b2_herp3_bs\\r_b5科室管理_科室人员查询_按科室查询人员_获取用户id.air')
    # from r_b5科室管理_科室人员查询_按科室查询人员_获取用户id import test1
    # userid = test1()
    # print(list_id)
    # for i in list_id:
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "basic_stockShelf_insert_url")
    # url=url+userid
    print(url)
    # 获取请求头信息
    headers = commonFuc().get_business_data(module, "json_headers2",
                                            commonFuc().get_business_data(module, "json_contentType"), token,
                                            commonFuc().get_business_data(module, "X-APP-CODE"))
    # branch_id = FileUtils().r_info(module, '院区新增')["branch_id"]
    # str1 = commonFuc().get_business_data(module, 'data14')
    # str = commonFuc().get_business_data(module, 'data3')
    # list2 = list(str.split(","))
    # print(list2)
    # #获取日期
    # date1=timeUtils().get_time_hms(2)
    # date2=timeUtils().get_time_hms(2)
    # for i in list2:

    # dept2_id = FileUtils().r_info(module, '科室信息')["dept2_id"]
    # 请求体
    request_body = commonFuc().get_business_data(module, "payload62_3",stockId)
    # request_body='['+str(request_body)+']'
    # new_request_body = request_body.replace("'", '"')
    # print(new_request_body)
    # import json
    # request_body_json = json.loads(new_request_body)
    # # # 发送请求
    result = commonFuc().http_post(url, request_body, headers)
    print('resultaaaaaaaaaaaaaaaaaaaaaaaaaaa', result)
    # 断言
    code = commonFuc().analysis_json('code', result)
    data = commonFuc().analysis_json('data', result)
    # data1 = commonFuc().analysis_json('data', data)
    # pageSize = commonFuc().analysis_json('pageSize', data)
    # print(pageSize, type(pageSize))
    if code == 0 and data == 1:
        commonFuc().check_text_exist(0, result)
    else:
        commonFuc().check_text_exist('error', result)
#从r_b9库房管理_库区设置_库房查询_查询全部.air获取库房id
pro_path = commonFuc().get_pro_path()
sys.path.append(pro_path + r'\\air_case\\b2_herp3_bs\\r_b9库房管理_库区设置_库房查询_查询全部.air')
using(pro_path + r'\\air_case\\b2_herp3_bs\\r_b9库房管理_库区设置_库房查询_查询全部.air')
from r_b9库房管理_库区设置_库房查询_查询全部 import test1
branch_name = FileUtils().r_info(module, '院区新增')["branch_name"]
stockId =test1(branch_name+'中心库房')
test2(stockId)
