# -*- encoding=utf8 -*-
import sys

from airtest.core.helper import using

from common.db.sql.sql_del_branch_info import delData
from common.db.sql.sql_del_kind_goodsinfo import delKindGoodsinfo
from common.db.sql.sql_del_notices_info import delByNoticeName
from common.fileUtls import FileUtils
from common.timeUtils import timeUtils

__author__ = "xiaohesheng"

"""
case_tag:api,herp-web,r_d2库房管理_库区设置_人员管理_添加人员,id2263,id2263-235,sit,on
内网:r_d2库房管理_库区设置_人员管理_添加人员
"""

from common.common_func import commonFuc
from air_case.b1_herp3_login.登录内网系统.登录内网系统 import login_system

module = "b2_herp3_bs"


def test3(dept_id='d69a68df361a4289b2262e4ef75b55a5', stockAreaId='b72a363163ff4670b4fa0390de5adb8c'):
    """
     场景:r_d2库房管理_库区设置_人员管理_添加人员
     用例名称：r_d2库房管理_库区设置_人员管理_添加人员
     输入：""
     输出："rtn_msg": {"code": 0, "msg": null,    "data":[]}
    """

    #登录获取用户id等信息，使用创建的用户登录===========开始
    info = FileUtils().r_info8(module, "用户名信息",'message3')
    print(info)
    username1 = info['username1']

    username = username1
    ## print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token1, projectCode1, uxid1, corpId1, info1 = login_system(username, password).get_token()
    # 登录获取用户id等信息，使用创建的用户登录============结束
    # 内网登录
    username = commonFuc().get_business_data(module, "username")
    ## print('医院名称',username)
    password = commonFuc().get_business_data(module, "password")
    # print(username, password,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')
    # 获取token和projectCode
    token, projectCode, uxid, corpId, info = login_system(username, password).get_token()
    # print( token,projectCode,uxid,corpId,info)

    # r_d2库房管理_库区设置_人员管理_添加人员
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "basic_stockUser_insert_url")
    # 获取请求头信息
    headers = commonFuc().get_business_data(module, "json_headers2",
                                            commonFuc().get_business_data(module, "json_contentType"), token,
                                            commonFuc().get_business_data(module, "X-APP-CODE"))

    # str = commonFuc().get_business_data(module, 'data3')
    # list2 = list(str.split(","))
    # print(list2)

    # for i in list2:

    # # 请求体
    request_body = commonFuc().get_business_data(module, "payload62_9",dept_id,stockAreaId,username1,uxid1,username1)
    # request_body = commonFuc().get_business_data(module, "payload62_9")
    request_body='['+str(request_body)+']'
    new_request_body = request_body.replace("'", '"')
    new_request_body = new_request_body.replace("None", 'null')
    print('new_request_body',new_request_body)
    import json
    request_body_json=""
    try:
        request_body_json = json.loads(new_request_body)
    except json.decoder.JSONDecodeError as e:
        print("JSONDecodeError:", str(e))
    # print('request_body',request_body)
    # # # # 发送请求
    result = commonFuc().http_post(url, request_body_json, headers)
    print('resultbbbbbbbbbbb', result)
    # 断言
    code = commonFuc().analysis_json('code', result)
    data = commonFuc().analysis_json('data', result)
    data1 = commonFuc().analysis_json('data', data)
    # print(type(data1))
    # pageSize = commonFuc().analysis_json('pageSize', data)
    # print(pageSize, type(pageSize))
    if code == 0 and data == 1:
        commonFuc().check_text_exist(0, result)
    else:
        commonFuc().check_text_exist('error', result)



#读取科室id
info = FileUtils().r_info8("b2_herp3_bs", "一级科室信息",'message4')
print(info)
dept1_id = info['dept1_id']
#获取库房id=========     开始====
pro_path = commonFuc().get_pro_path()
sys.path.append(pro_path + r'\\air_case\\b2_herp3_bs\\r_b9库房管理_库区设置_库房查询_查询全部.air')
using(pro_path + r'\\air_case\\b2_herp3_bs\\r_b9库房管理_库区设置_库房查询_查询全部.air')
from r_b9库房管理_库区设置_库房查询_查询全部 import test1
branch_name = FileUtils().r_info(module, '院区新增')["branch_name"]
stockId =test1(branch_name+'中心库房')
#获取库房id==========结束============

#====获取库区id===== 开始==========
sys.path.append(pro_path + r'\\air_case\\b2_herp3_bs\\r_c5库房管理_库区设置_库区查询_查询全部.air')
using(pro_path + r'\\air_case\\b2_herp3_bs\\r_c5库房管理_库区设置_库区查询_查询全部.air')
from r_c5库房管理_库区设置_库区查询_查询全部 import test2
stockAreaId=test2(dept1_id,stockId)
#====获取库区id===== 结束==========
test3(dept1_id,stockAreaId)

